/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: GuiStarterFirstFrame.java 20819 2011-02-02 16:00:53Z benoitf $
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.autostart.frame;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.Insets;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SpringLayout;
import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;

import org.ow2.jonas.autostart.utility.SpringUtilities;

/**
 * This class creates the first frame panel.
 * @author skabore
 */
public final class GuiStarterFirstFrame extends FirstFrame {

    public GuiStarterFirstFrame(final int steps) {
        super(steps);
        makeFrame();
    }

    @Override
    public JPanel getContentPanel() {

        JPanel contentPanel1 = new JPanel();
        JPanel jPanel1 = new JPanel(new SpringLayout());
        JPanel jPanelStep1 = new JPanel(new SpringLayout());
        JPanel jPanelStep2 = new JPanel(new SpringLayout());
        JPanel jPanelStep3 = new JPanel(new SpringLayout());
        JPanel jPanelStep4 = new JPanel(new SpringLayout());
        JPanel jPanelStep6 = new JPanel(new SpringLayout());
        JPanel jPanelStep7 = new JPanel(new SpringLayout());

        JLabel blankSpace = new JLabel();
        JLabel jLabel1 = new JLabel("This tool allows users to start JOnAS server.");
        jLabel1.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel2 = new JLabel("Read and accept the license agreements.");
        jLabel2.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel3 = new JLabel("Choose JOnAS server to start. You have two" + " options:");
        jLabel3.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel3a = new JLabel("- From embedded JOnAS: If you choose this option," + " the embedded JOnAS server will be");
        jLabel3a.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel3b = new JLabel("  extracted, installed" + " on your disk. The server will be launched using this new"
                + " folder.");
        jLabel3b.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel3c = new JLabel("- From existing JOnAS folder:" + " Be sure you have a valid JOnAS server folder on"
                + " your disk.");
        jLabel3c.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel3d = new JLabel("  If the current directory contains a valid"
                + " JOnAS folder, the startup program will detect");
        jLabel3d.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel3e = new JLabel("  it and" + " fill the coresponding field.");
        jLabel3e.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel jLabel4 = new JLabel("In the previous step, if you had chosen:");
        jLabel4.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel4a = new JLabel("- From embedded JOnAS option, you need to enter a" + " location where JOnAS Root");
        jLabel4a.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel4b = new JLabel("  (optionally JOnAS Base) " + "will be installed");
        jLabel4b.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel4c = new JLabel("- From existing JOnAS folder option, you need to" + " enter the JOnAS Root");
        jLabel4c.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel4d = new JLabel("  (optionally JOnAS Base) " + "folder.");
        jLabel4d.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel jLabel6 = new JLabel("You can see, in the text area, step by step" + " the startup process.");
        jLabel6.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel jLabel7 = new JLabel("You can deploy new Java EE applications.");
        jLabel7.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel jLabel9 = new JLabel("Press the 'Next' button to continue...");
        jLabel9.setFont(new Font(Font.SERIF, Font.BOLD, 14));

        JLabel step1 = new JLabel(underLineLabel("Step :1 Introduction note"));
        step1.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step2 = new JLabel(underLineLabel("Step 2: License agreements"));
        step2.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step3 = new JLabel(underLineLabel("Step 3: What JOnAS ?"));
        step3.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step4 = new JLabel(underLineLabel("Step 4:" + " JOnAS server (install) location"));
        step4.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step6 = new JLabel(underLineLabel("Step 7: Startup process"));
        step6.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step7 = new JLabel(underLineLabel("Step 5: (Optional) Deploy new " + "applications"));
        step7.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        contentPanel1.setLayout(new BorderLayout());

        JPanel titlePanel = new JPanel();
        titlePanel.setLayout(new BorderLayout());
        titlePanel.setBackground(Color.gray);

        getWelcomeTitle().setBackground(Color.gray);
        getWelcomeTitle().setFont(new Font("MS Sans Serif", Font.BOLD, 14));
        getWelcomeTitle().setText("Welcome to JOnAS AutoStart :: Starter !");
        getWelcomeTitle().setBorder(new EmptyBorder(new Insets(10, 10, 10, 10)));
        getWelcomeTitle().setOpaque(true);
        titlePanel.add(getWelcomeTitle(), BorderLayout.CENTER);
        titlePanel.add(getSeparator(), BorderLayout.SOUTH);
        titlePanel.add(new JLabel("1/" + getSteps() + "  "), BorderLayout.EAST);
        contentPanel1.add(titlePanel, BorderLayout.NORTH);

        jPanel1.add(blankSpace);

        jPanelStep1.add(step1);
        jPanelStep1.add(jLabel1);
        SpringUtilities.makeCompactGrid(jPanelStep1, 2, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep1);

        jPanelStep2.add(step2);
        jPanelStep2.add(jLabel2);
        SpringUtilities.makeCompactGrid(jPanelStep2, 2, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep2);

        jPanelStep3.add(step3);
        jPanelStep3.add(jLabel3);
        jPanelStep3.add(jLabel3a);
        jPanelStep3.add(jLabel3b);
        jPanelStep3.add(jLabel3c);
        jPanelStep3.add(jLabel3d);
        jPanelStep3.add(jLabel3e);
        SpringUtilities.makeCompactGrid(jPanelStep3, 7, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep3);

        jPanelStep4.add(step4);
        jPanelStep4.add(jLabel4);
        jPanelStep4.add(jLabel4a);
        jPanelStep4.add(jLabel4b);
        jPanelStep4.add(jLabel4c);
        jPanelStep4.add(jLabel4d);
        SpringUtilities.makeCompactGrid(jPanelStep4, 6, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep4);

        jPanelStep7.add(step7);
        jPanelStep7.add(jLabel7);
        SpringUtilities.makeCompactGrid(jPanelStep7, 2, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep7);

        jPanelStep6.add(step6);
        jPanelStep6.add(jLabel6);
        SpringUtilities.makeCompactGrid(jPanelStep6, 2, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep6);

        jPanel1.add(new JLabel(" "));
        jPanel1.add(jLabel9);
        SpringUtilities.makeCompactGrid(jPanel1, 9, 1, 6, 6, 6, 6);
        contentPanel1.add(jPanel1, BorderLayout.CENTER);
        return contentPanel1;
    }

    @Override
    public void makeFrame() {
        setContentPanel(getContentPanel());
        setIcon(getImageIcon());
        setLayout(new SpringLayout());
        if (getIcon() != null) {
            getIconLabel().setIcon(getIcon());
        }
        getIconLabel().setBorder(new EtchedBorder(EtchedBorder.RAISED));
        add(getIconLabel());
        getContentPanel().setBorder(new EtchedBorder(EtchedBorder.RAISED));
        add(getContentPanel());
        SpringUtilities.makeCompactGrid(this, 1, 2, 0, 0, 0, 0);
    }
}
